#include <My_Structs.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <math.h>
#include <assert.h>
#include <glide.h>
#include <My_Clip.h>
#include <My_load2.h>
#include <My_3dRR.h>
#include <My_Graphics.h>
#include <My_Texture.h>
#include <My_Lighten.h>





float	rot=0,rot2=4,rot3=0;
int		np,i;
float	x,y,a=0.5;



void main(void) 
{	D3Object mozart;
	//TgaObject Plaatje;
	TextureMap flare[4];
	PartSystem Sys;

	SetupParticleSystem(&Sys);

	SetupGlide();
	
	LoadAscFile("mozart.asc", &mozart, 1.0); 

	//LoadTga("future.tga",&Plaatje);

	LoadTexture("lens1.3df", &flare[0]);
	LoadTexture("lens2.3df", &flare[1]);
	LoadTexture("lens3.3df", &flare[2]);
	LoadTexture("lens4.3df", &flare[3]);

	grColorCombine(	GR_COMBINE_FUNCTION_SCALE_OTHER,GR_COMBINE_FACTOR_LOCAL,
					GR_COMBINE_LOCAL_ITERATED,GR_COMBINE_OTHER_TEXTURE,FXFALSE);

	for (i=0; i<mozart.NumVertices; i++)
	{	mozart.Vertices_local[i].r = 255;
		mozart.Vertices_local[i].g = 255;
		mozart.Vertices_local[i].b = 255;
	}

	mozart.Spotlight.x =  500;
	mozart.Spotlight.y = -500;
	mozart.Spotlight.z = -500;
	mozart.Spotlight.r = 255;
	mozart.Spotlight.g = 200;
	mozart.Spotlight.b = 100;

	PositionParticleSystem(&Sys,-300,200,300);

	PositionObject(&mozart,0,0,0);

	PositionCamera(0,0,-400);


	//////////////////////////////////////// MAIN //////////////////////////////////
	while (kbhit()==false) 
	{	
		grBufferClear(0,0,0);
		//grLfbWriteRegion(GR_BUFFER_BACKBUFFER,0,0,GR_LFB_SRC_FMT_565,640,480,FXFALSE,1280,Plaatje.Data);
		
		RotateObject((D3Object_ptr)&mozart,rot,rot2,rot3);	
		RotateVertexNormals((D3Object_ptr)&mozart,rot,rot2,rot3);	
		
		Local_To_World_Object((D3Object_ptr)&mozart);
		World_To_Camera_Object((D3Object_ptr)&mozart);
		
		ClipObject(&mozart);

		LightenObject((D3Object_ptr)&mozart);
		RenderObject((D3Object_ptr)&mozart);

		TranslateObject(&mozart, 0,0,0);

		x = mozart.Vertices_screen[500].x;
		y = mozart.Vertices_screen[500].y;

		RenderLensFlare(&flare[0],&flare[1],&flare[2],&flare[3],x,y-100,64,400,300);

		RenderParticleSystem(&Sys, &flare[0], 0,0,0);
		
		//RotateCamera(0,1,0);


		grBufferSwap(1);
	}

	ShutdownGlide();
}