#include <My_Structs.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <math.h>
#include <assert.h>
#include <glide.h>
#include <My_load2.h>
#include <My_3dRR.h>



#define XMID			400
#define YMID			300

int		arc=0,arc2=0,arc3=0;
float	rot=0,rot2=1,rot3=0;
int		np,i;
long	n;




void main(void)
{	
	
	// Make an D3Object-datatype named tures -- The name is not important
	D3Object tures;

	// Now setup your Voodoo card
	GrContext_t context;
	grGlideInit();
	
	if (! grGet(GR_NUM_BOARDS, sizeof(n), &n))
	{	printf("Error: Sorry, no 3DFX Graphics Accelerator detected...");
	}
	
	grSstSelect(0);
	
	// Make a window
	context = grSstWinOpen(NULL,	GR_RESOLUTION_800x600, 
									GR_REFRESH_60Hz, 
									GR_COLORFORMAT_RGBA, 
									GR_ORIGIN_UPPER_LEFT, 2, 0);

	// Tell glide how to combine the colors on your screen
	grColorCombine(	GR_COMBINE_FUNCTION_LOCAL, 
					GR_COMBINE_FACTOR_NONE,
					GR_COMBINE_LOCAL_ITERATED, 
					GR_COMBINE_OTHER_NONE, FXFALSE);
	
	// Set the vertexlayout --> see "My_Struct.h" !
	SetVertexLayout();


	// This does nothing.. The logo just looks professional 
	grEnable(GR_SHAMELESS_PLUG);

	// Enable depthbuffering
	grDepthBufferMode( GR_DEPTHBUFFER_WBUFFER );
	grDepthBufferFunction( GR_CMP_GREATER );
	grDepthMask( FXTRUE );

	// Now use my own function "LoadAscFile" to, as you guest, load an Asc file
	// It is loaded into our datatype D3Object named "tures"
	LoadAscFile("Mozart.asc", &tures, 1.0);
	MakeLookUp();

	// As there is no texturesupport, make all vertices white so they are seen agains 
	// a black background
	for (i=0; i<tures.NumVertices; i++)
	{	tures.Vertices_local[i].r = 255;
		tures.Vertices_local[i].g = 255;
		tures.Vertices_local[i].b = 255;
	}
	
	// Specify a spotlight which lights our object
	tures.SpotlightStat.x =  500;
	tures.SpotlightStat.y = -500;
	tures.SpotlightStat.z = -500;

	//////////////////////////////////////// MAIN //////////////////////////////////
	while (np!=' ') 
	{	
		grBufferClear(0,0,0);
	
		// These are my own routines. See "My_3dRR.h"
		RotateObject((D3Object_ptr)&tures,arc,arc2,arc3);	
		RotateVertexNormals((D3Object_ptr)&tures,arc,arc2,arc3);	
		
		LightenObject((D3Object_ptr)&tures);
		RenderObject((D3Object_ptr)&tures, XMID, YMID);


		if (kbhit())
		{	np=getch();	
		}
		else
		{	np=0;};
		
		arc=arc+rot;
		arc2=arc2+rot2;
		arc3=arc3+rot3;

		if (arc>= 360)	{ arc=0;	};
		if (arc2>=360)	{ arc2=0;	};
		if (arc3>=360)	{ arc3=0;	};
		if (arc< 0)		{ arc=359;	};
		if (arc2<0)		{ arc2=359; };
		if (arc3<0)		{ arc3=359; };
		if (np=='4')	{ rot2=1;	};
		if (np=='6')	{ rot2=-1;	};

		grBufferSwap(1);
	}

	printf("This program was made by Tommy Krul 1998\n");
	// Shutdown Glide
	grSstWinClose(context);
	grGlideShutdown();
}


